#include <owl.h>
#include <stdio.h>
#include <conio.h>

#include <toolhelp.h>
#include <list.h>
#include "toolrc.h"

class TMyApp : public TApplication
{
public:
  TMyApp(LPSTR AName, HANDLE hInstance, HANDLE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
	: TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow) {};
  virtual void InitMainWindow();
};



_CLASSDEF( TMyWindow )
class TMyWindow : public TWindow
{
public:
	TMyWindow( PTWindowsObject, LPSTR );
	~TMyWindow();
	virtual void SetupWindow();
	virtual void ShutDownWindow();
	virtual LPSTR GetClassName();
	virtual void GetWindowClass( WNDCLASS _FAR & );
	virtual void CMUAE( RTMessage ) = [ CM_FIRST + CM_UAE ];
};


void TMyWindow::CMUAE( RTMessage )
{
/* *************************************
 * cause a UAE
 * *************************** */
	for ( int i = 0; i < 100; i++ )
		_ES = i;
	label:
		return;
}



TMyWindow::TMyWindow( PTWindowsObject p, LPSTR s ) : TWindow( p, s )
{
	AssignMenu("MENU_1");

}

TMyWindow::~TMyWindow()
{
}

extern WORD _hInstance;
extern "C" 	int MYCALLBACK();

void TMyWindow::SetupWindow()
{
	TWindow::SetupWindow();
	FARPROC p = MakeProcInstance( (FARPROC) MYCALLBACK , _hInstance );
/* *****************************************
 * Step 1: Registering an interrupt handler, you should use MakeProcInstance.
 *	 NULL identifies the task, this is for registration purposes.
 * ******************************************* */
	if ( ! InterruptRegister( NULL , p  )   )
	{
		MessageBox( HWindow , "Register Interrupt Failed",
			"", MB_OK );
	}
	_InitEasyWin();
}

/* ****************

0 pass on
1 terminate
2 restart
   **************** */

#pragma argsused
extern "C" int TOOLCALLBACK
	(
        WORD wDS,
        WORD wES,
        WORD wDI,
        WORD wSI,
        WORD wBP,
        WORD wSP,
        WORD wBX,
        WORD wDX,
        WORD wCX,
        WORD wAX,
        WORD wTH_IP,
        WORD wTH_CS,
        WORD wTH_AX,
        WORD wIntNum,
        WORD wHandle,
        WORD wIP,
        WORD wCS,
        WORD wFlags
	)
/* ***************************************
 * Step 3
 * The C callback
 * *************************************** */
{
	printf( "Call Back called: SS = %X SP = %x DS= %X Exception No %d\n",
		_SS, _SP, _DS, wIntNum );
	getch();
	char szInstructions[ 21 ];
	MemoryRead( wCS, wIP,  szInstructions , 20 );

	printf("Exception is at %X : %X, dump:\n", wCS, wIP );
	for ( int i = 0; i < 20; i ++ )
		printf("%X ", szInstructions[i] );
	printf("\n");

	printf( "Do you want to terminate? ");
	char ans[20];
	gets( ans );
	if ( ! lstrcmpi( ans, "y" ) ) {
		return 1;
	}
	printf("Do you want to ignore? ");
	gets(ans);
	if ( !lstrcmpi( ans, "y"))
		return 0;

	printf("Do you want to NOP stuff?");
	gets( ans );
	if ( !lstrcmpi( ans, "y" ))
	{
		static int szNOP[] = { 0x90 , 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90 };
		int nLength = 2;
		MemoryWrite( wCS, wIP, szNOP, nLength );
		return 2;
	}
	printf("going to ignore\n");
	return 0;
}



void TMyWindow::ShutDownWindow()
{
	TWindow::ShutDownWindow();
}

LPSTR TMyWindow::GetClassName()
{
	return "MYWINDOW";
}
void TMyWindow::GetWindowClass( WNDCLASS _FAR & wc )
{
    TWindow::GetWindowClass( wc );
}

void TMyApp::InitMainWindow()
{
  MainWindow = new TMyWindow(NULL, Name);
}

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  TMyApp MyApp("Sample ObjectWindows Program", hInstance, hPrevInstance,
               lpCmdLine, nCmdShow);
  MyApp.Run();
  return MyApp.Status;
}
